//+------------------------------------------------------------------+
//|                                            Create_Tick_Chart.mq5 |
//+------------------------------------------------------------------+
#property copyright "Copyright © 2018, avoitenko"
#property link      "https://www.mql5.com/en/users/avoitenko"
#property version   "2.00"
#property script_show_inputs

#define N         500000
#define SPREAD    5
#define PERIOD    PeriodSeconds(PERIOD_M1)
#include <Canvas\iCanvas.mqh> //https://www.mql5.com/ru/code/22164
input datetime InpDateSart=D'1970.01.01';//Начало истории
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int random(const int _min,const int _max)
  {
   int delta=_max-_min+1;
   return rand()%delta+_min;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime GetTimeDay(const datetime _dt)
  {
   MqlDateTime mdt;
   TimeToStruct(_dt,mdt);
   mdt.hour=0;
   mdt.min=0;
   mdt.sec=0;
   return StructToTime(mdt);
  }
//+------------------------------------------------------------------+
void CreateSymbol(const string _symbol,// имя нового инструмента
                  const string _source_symbol) // инструмент c которого копируются настройки

  {
//--- спрятать
   SymbolSelect(_symbol,false);

//--- пересоздать инструмент
   CustomSymbolDelete(_symbol);
   CustomSymbolCreate(_symbol,"Custom\\"+_symbol);

//--- скопирвоать все параметры
   CopySymbolProperties(_source_symbol,_symbol);

//--- присвоить нужные параметры
   CustomSymbolSetInteger(_symbol,SYMBOL_BACKGROUND_COLOR,clrPink);
   CustomSymbolSetInteger(_symbol,SYMBOL_CHART_MODE,SYMBOL_CHART_MODE_BID);
   CustomSymbolSetInteger(_symbol,SYMBOL_SPREAD_FLOAT,false);
   CustomSymbolSetInteger(_symbol,SYMBOL_TRADE_STOPS_LEVEL,SPREAD);

//--- показать
   SymbolSelect(_symbol,true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CopySymbolProperties(const string source,const string dest)
  {

   CustomSymbolSetString(dest,SYMBOL_BASIS,SymbolInfoString(source,SYMBOL_BASIS));
   CustomSymbolSetString(dest,SYMBOL_CURRENCY_BASE,SymbolInfoString(source,SYMBOL_CURRENCY_BASE));
   CustomSymbolSetString(dest,SYMBOL_CURRENCY_PROFIT,SymbolInfoString(source,SYMBOL_CURRENCY_PROFIT));
   CustomSymbolSetString(dest,SYMBOL_CURRENCY_MARGIN,SymbolInfoString(source,SYMBOL_CURRENCY_MARGIN));
   CustomSymbolSetString(dest,SYMBOL_DESCRIPTION,SymbolInfoString(source,SYMBOL_DESCRIPTION));
   CustomSymbolSetString(dest,SYMBOL_ISIN,SymbolInfoString(source,SYMBOL_ISIN));

   CustomSymbolSetInteger(dest,SYMBOL_CUSTOM,true);
   CustomSymbolSetInteger(dest,SYMBOL_SPREAD_FLOAT,SymbolInfoInteger(source,SYMBOL_SPREAD_FLOAT));
   CustomSymbolSetInteger(dest,SYMBOL_DIGITS,SymbolInfoInteger(source,SYMBOL_DIGITS));
   CustomSymbolSetInteger(dest,SYMBOL_TICKS_BOOKDEPTH,SymbolInfoInteger(source,SYMBOL_TICKS_BOOKDEPTH));
   CustomSymbolSetInteger(dest,SYMBOL_CHART_MODE,SymbolInfoInteger(source,SYMBOL_CHART_MODE));
   CustomSymbolSetInteger(dest,SYMBOL_TRADE_CALC_MODE,SymbolInfoInteger(source,SYMBOL_TRADE_CALC_MODE));
   CustomSymbolSetInteger(dest,SYMBOL_TRADE_MODE,SymbolInfoInteger(source,SYMBOL_TRADE_MODE));
   CustomSymbolSetInteger(dest,SYMBOL_START_TIME,SymbolInfoInteger(source,SYMBOL_START_TIME));
   CustomSymbolSetInteger(dest,SYMBOL_EXPIRATION_TIME,SymbolInfoInteger(source,SYMBOL_EXPIRATION_TIME));
   CustomSymbolSetInteger(dest,SYMBOL_TRADE_STOPS_LEVEL,SymbolInfoInteger(source,SYMBOL_TRADE_STOPS_LEVEL));
   CustomSymbolSetInteger(dest,SYMBOL_TRADE_FREEZE_LEVEL,SymbolInfoInteger(source,SYMBOL_TRADE_FREEZE_LEVEL));
   CustomSymbolSetInteger(dest,SYMBOL_TRADE_EXEMODE,SymbolInfoInteger(source,SYMBOL_TRADE_EXEMODE));
   CustomSymbolSetInteger(dest,SYMBOL_SWAP_MODE,SymbolInfoInteger(source,SYMBOL_SWAP_MODE));
   CustomSymbolSetInteger(dest,SYMBOL_SWAP_ROLLOVER3DAYS,SymbolInfoInteger(source,SYMBOL_SWAP_ROLLOVER3DAYS));
   CustomSymbolSetInteger(dest,SYMBOL_MARGIN_HEDGED_USE_LEG,SymbolInfoInteger(source,SYMBOL_MARGIN_HEDGED_USE_LEG));
   CustomSymbolSetInteger(dest,SYMBOL_EXPIRATION_MODE,SymbolInfoInteger(source,SYMBOL_EXPIRATION_MODE));
   CustomSymbolSetInteger(dest,SYMBOL_FILLING_MODE,SymbolInfoInteger(source,SYMBOL_FILLING_MODE));
   CustomSymbolSetInteger(dest,SYMBOL_ORDER_MODE,SymbolInfoInteger(source,SYMBOL_ORDER_MODE));
   CustomSymbolSetInteger(dest,SYMBOL_ORDER_GTC_MODE,SymbolInfoInteger(source,SYMBOL_ORDER_GTC_MODE));
   CustomSymbolSetInteger(dest,SYMBOL_OPTION_MODE,SymbolInfoInteger(source,SYMBOL_OPTION_MODE));
   CustomSymbolSetInteger(dest,SYMBOL_OPTION_RIGHT,SymbolInfoInteger(source,SYMBOL_OPTION_RIGHT));

   CustomSymbolSetDouble(dest,SYMBOL_POINT,SymbolInfoDouble(source,SYMBOL_POINT));
   CustomSymbolSetDouble(dest,SYMBOL_TRADE_TICK_VALUE,SymbolInfoDouble(source,SYMBOL_TRADE_TICK_VALUE));
   CustomSymbolSetDouble(dest,SYMBOL_TRADE_TICK_VALUE_PROFIT,SymbolInfoDouble(source,SYMBOL_TRADE_TICK_VALUE_PROFIT));
   CustomSymbolSetDouble(dest,SYMBOL_TRADE_TICK_VALUE_LOSS,SymbolInfoDouble(source,SYMBOL_TRADE_TICK_VALUE_LOSS));
   CustomSymbolSetDouble(dest,SYMBOL_TRADE_TICK_SIZE,SymbolInfoDouble(source,SYMBOL_TRADE_TICK_SIZE));
   CustomSymbolSetDouble(dest,SYMBOL_TRADE_FACE_VALUE,SymbolInfoDouble(source,SYMBOL_TRADE_FACE_VALUE));
   CustomSymbolSetDouble(dest,SYMBOL_TRADE_LIQUIDITY_RATE,SymbolInfoDouble(source,SYMBOL_TRADE_LIQUIDITY_RATE));
   CustomSymbolSetDouble(dest,SYMBOL_VOLUME_MIN,SymbolInfoDouble(source,SYMBOL_VOLUME_MIN));
   CustomSymbolSetDouble(dest,SYMBOL_VOLUME_MAX,SymbolInfoDouble(source,SYMBOL_VOLUME_MAX));
   CustomSymbolSetDouble(dest,SYMBOL_VOLUME_STEP,SymbolInfoDouble(source,SYMBOL_VOLUME_STEP));
   CustomSymbolSetDouble(dest,SYMBOL_VOLUME_LIMIT,SymbolInfoDouble(source,SYMBOL_VOLUME_LIMIT));
   CustomSymbolSetDouble(dest,SYMBOL_SWAP_LONG,SymbolInfoDouble(source,SYMBOL_SWAP_LONG));
   CustomSymbolSetDouble(dest,SYMBOL_SWAP_SHORT,SymbolInfoDouble(source,SYMBOL_SWAP_SHORT));
   CustomSymbolSetDouble(dest,SYMBOL_MARGIN_INITIAL,SymbolInfoDouble(source,SYMBOL_MARGIN_INITIAL));
   CustomSymbolSetDouble(dest,SYMBOL_MARGIN_MAINTENANCE,SymbolInfoDouble(source,SYMBOL_MARGIN_MAINTENANCE));
   CustomSymbolSetDouble(dest,SYMBOL_MARGIN_HEDGED,SymbolInfoDouble(source,SYMBOL_MARGIN_HEDGED));
   CustomSymbolSetDouble(dest,SYMBOL_TRADE_CONTRACT_SIZE,SymbolInfoDouble(source,SYMBOL_TRADE_CONTRACT_SIZE));

  }
//+------------------------------------------------------------------+
//|   OnStart                                                        |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   srand(GetTickCount());

//--- создаем инструмент
   string _symbol=StringFormat("%s_T1",_Symbol);
   CreateSymbol(_symbol,_Symbol);

//--- массив тиков
   MqlTick ticks[];
   ArrayResize(ticks,N);

//--- первый тик
   ticks[0].bid=1.0;// начальная цена
   ticks[0].ask=NormalizeDouble(ticks[0].bid+SPREAD*_Point,_Digits);
   ticks[0].last=0;
   ticks[0].flags=TICK_FLAG_BID;
   ticks[0].volume=1;
   ticks[0].volume_real=1;
   ticks[0].time=GetTimeDay(InpDateSart);
   ticks[0].time_msc=ticks[0].time*1000;

//--- массив баров
   MqlRates bars[];
   ArrayResize(bars,N);

//--- первый бар
   bars[0].open=ticks[0].bid;
   bars[0].high=ticks[0].bid;
   bars[0].low=ticks[0].bid;
   bars[0].close=ticks[0].bid;
   bars[0].tick_volume=1;
   bars[0].real_volume=1;
   bars[0].spread=SPREAD;
   bars[0].time=ticks[0].time;

//---
   for(int i=1; i<N; i++)
     {
      //--- направление
      int dir=random(-1,1);
      //--- величина движения
      int mov=random(-20,20);
      double size=dir*mov*_Point;
      //---
      if(dir==0)
         size=mov*0.1*_Point;

      //---
      ticks[i].bid=NormalizeDouble(ticks[i-1].bid+size,_Digits);
      ticks[i].ask=NormalizeDouble(ticks[i].bid+SPREAD*_Point,_Digits);
      ticks[i].last=0;
      ticks[i].volume=1;
      ticks[i].volume_real=1;
      ticks[i].flags=TICK_FLAG_BID;
      ticks[i].time=ticks[i-1].time+PERIOD;
      ticks[i].time_msc=ticks[i].time*1000;

      //---
      bars[i].open=ticks[i].bid;
      bars[i].high=ticks[i].bid;
      bars[i].low=ticks[i].bid;
      bars[i].close=ticks[i].bid;
      bars[i].tick_volume=1;
      bars[i].real_volume=1;
      bars[i].spread=SPREAD;
      bars[i].time=bars[i-1].time+PERIOD;
     }

//--- сохраняем тики
   int ticks_result=CustomTicksReplace(_symbol,ticks[0].time_msc,ticks[N-1].time_msc,ticks);
   if(ticks_result==-1)
      Print("Ошибка CustomTicksReplace: ",_LastError);
   else if(ticks_result!=N)
                         Print("Сохранениы не все тики: ",ticks_result," из ",N," ,ошибка ",_LastError);

//--- сохраняем бары
   int rates_result=CustomRatesReplace(_symbol,bars[0].time,bars[N-1].time,bars);
   if(rates_result==-1)
      Print("Oшибка CustomRatesReplace: ",_LastError);
   else if(rates_result!=N)
                         Print("Сохранениы не все бары: ",rates_result," из ",N," ,ошибка",_LastError);

//--- показать в Обзоре рынка
   SymbolSelect(_symbol,true);

//--- открыть и настроить график
   if(ticks_result==N && rates_result==N)
     {
      long chart_id=ChartOpen(_symbol,PERIOD_M1);
      long chart_id2=ChartID();
      ChartSetInteger(chart_id,CHART_SHOW_GRID,false);
      ChartSetInteger(chart_id,CHART_AUTOSCROLL,false);
      ChartSetInteger(chart_id,CHART_SCALE,0);
      ChartSetInteger(chart_id,CHART_SHIFT,true);

      //--- прокрутка на старт
      ChartSetInteger(chart_id,CHART_BRING_TO_TOP,true);
      ChartNavigate(chart_id,CHART_BEGIN,0);

      delete Canvas;
      Canvas=new iCanvas(chart_id);
      Canvas.FillRectangle(100,100,500,500,ColorToARGB(clrGreen,150));
      Canvas.FillCircle(400,300,110,ColorToARGB(clrBeige,230));
      Canvas.Update();
      Sleep(6000);
     }
  }
//+------------------------------------------------------------------+
